﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Stego_App
{
    public partial class DecryptionForm : Form
    {
        public DecryptionForm()
        {
            InitializeComponent();
        }

        private void DecryptionForm_Load(object sender, EventArgs e)
        {
            DecryptionForm.CheckForIllegalCrossThreadCalls = false;
        }

        private void btnLoadKey_Click(object sender, EventArgs e)
        {
            if (keyfiledialog.ShowDialog() == DialogResult.OK)
            {
                tbKeyFile.Text = keyfiledialog.FileName;
            }

        }

        private void btnLoadStego_Click(object sender, EventArgs e)
        {
            OpenFileDialog of = new OpenFileDialog();
            if (of.ShowDialog() == DialogResult.OK)
            {
                tbStego.Text = of.FileName;
            }
        }

        public void btnDecrypt_Click(object sender, EventArgs e)
        {
            string keyfilename = tbKeyFile.Text;
            if (keyfilename == "")
            {
                MessageBox.Show("Key file name cannot be blank!");
                return;
            }
            string keyfileinfo = Decode64(File.ReadAllText(tbKeyFile.Text));
            if (keyfilename == "error")
            {
                return;
            }
            else
            {
                File.WriteAllText("tmpfile",keyfileinfo);

                // now we need to grab the contents of the key file, parse it or something. was thinking something along the lines of:
                // <enctype><newline><lengthoforiginaljpg><newline><lengthofencodedexe><newline><keyvalue><newline><GironSec>
                
                
                //line   1        2       3       4       5
                string enctype, piclen, exelen, keyval, giron;
                string stegofile = tbStego.Text;
                // present method of using a foreach loop to assign values above by reading file line by line ineffective. Need a way
                // to read line X
                // like so
                string[] allLines = File.ReadAllLines("tmpfile");
                string line = string.Empty;
                enctype = allLines[0];
                piclen = allLines[1];
                exelen = allLines[2];
                keyval = allLines[3];
                giron = allLines[4];

                // now we can decode, we do this by reading the loaded picfile's byte stream and performing a linq skip by the piclength, then we for loop through the rest of the data and decrypt
                // will be different for RC4
                // also need to figure out how to do RC4 with binary instead of string data for NULL byte reasons. 
                switch (enctype)
                {
                    case "XOR":
                        
                        byte[] buffer1 = File.ReadAllBytes(stegofile);
			            var newArray = buffer1.Skip(Convert.ToInt32(piclen)).ToArray(); // skip past the pic length since we only want the program at the end
                        
                        byte[] resultBuffer = new byte[newArray.Length];
                        for (int i = 0; i < newArray.Length; i++)
                        {
                        resultBuffer[i] = (byte)(newArray[i] ^ Convert.ToInt32(keyval));
                        }
			            if(resultBuffer.Length == Convert.ToInt32(exelen))
			            {
			            File.WriteAllBytes(stegofile + "_decrypted", resultBuffer); // now we can save over it. 
                        lblResult.Text += " Complete!";
			            }
			            else
			            {
			            MessageBox.Show("Corrupted file!");
			            return;
			            }
                        
                        break;
                    case "OR":
                        byte[] buff2 = File.ReadAllBytes(stegofile);
                        var newArray2 = buff2.Skip(Convert.ToInt32(piclen)).ToArray();
                        byte[] resultBuffer2 = new byte[newArray2.Length];
                        for (int i = 0; i < newArray2.Length; i++)
                        {
                            resultBuffer2[i] = (byte)(newArray2[i] | Convert.ToInt32(keyval));
                        }
                        if (resultBuffer2.Length == Convert.ToInt32(exelen))
                        {
                            File.WriteAllBytes(stegofile + "_decrypted", resultBuffer2); // now we can save over it. 
                            lblResult.Text += " Complete!";
                        }
                        else
                        {
                            MessageBox.Show("Corrupted file!");
                            return;
                        }
                        break;
                    case "Left Shift":
                        byte[] buff3 = File.ReadAllBytes(stegofile);
                        var newArray3 = buff3.Skip(Convert.ToInt32(piclen)).ToArray();
                        byte[] resultBuffer3 = new byte[newArray3.Length];
                        for (int i = 0; i < newArray3.Length; i++)
                        {
                            resultBuffer3[i] = (byte)(newArray3[i] << Convert.ToInt32(keyval));
                        }
                        if (resultBuffer3.Length == Convert.ToInt32(exelen))
                        {
                            File.WriteAllBytes(stegofile + "_decrypted", resultBuffer3); // now we can save over it. 
                            lblResult.Text += " Complete!";
                        }
                        else
                        {
                            MessageBox.Show("Corrupted file!");
                            return;
                        }
                        break;
                    case "Right Shift":
                        byte[] buff4 = File.ReadAllBytes(stegofile);
                        var newArray4 = buff4.Skip(Convert.ToInt32(piclen)).ToArray();

                        byte[] resultBuffer4 = new byte[newArray4.Length];
                        for (int i = 0; i < newArray4.Length; i++)
                        {
                            resultBuffer4[i] = (byte)(newArray4[i] | Convert.ToInt32(keyval));
                        }
                        if (resultBuffer4.Length == Convert.ToInt32(exelen))
                        {
                            File.WriteAllBytes(stegofile + "_decrypted", resultBuffer4); // now we can save over it. 
                            lblResult.Text += " Complete!";
                        }
                        else
                        {
                            MessageBox.Show("Corrupted file!");
                            return;
                        }
                        break;
                    case "RC4":
                        byte[] buff5 = File.ReadAllBytes(stegofile);
                        var newArray5 = buff5.Skip(Convert.ToInt32(piclen)).ToArray();
                        RC4Encryptor r4u = new RC4Encryptor(StringToByteArray(keyval));
                        r4u.Decrypt(newArray5);
                        File.WriteAllBytes(stegofile + "_decrypted",newArray5); // giroTMP now has the secret file in it.
                        lblResult.Text += " Complete!";
                        break;
                }
                File.Delete("tmpfile"); // clean up temp key file

            }
        }
                
        public string Decode64(string str)
        {
            try
            {
                byte[] decbuff = Convert.FromBase64String(str);
                return System.Text.Encoding.UTF8.GetString(decbuff);
            }
            catch (Exception)
            {
                MessageBox.Show("Something is wrong with the key file. Corrupted perhaps?");
                return "error";
            }

        }

        private byte[] StringToByteArray(string s)
        {
            if (s.Length == 0)
                throw new ArgumentException("Invalid argument: s must be non-empty string.");

            byte[] bt = new byte[s.Length * sizeof(char)];
            Buffer.BlockCopy(s.ToCharArray(), 0, bt, 0, bt.Length);
            return bt;
        }
        
    }


    public class RC4U
    {

        private byte[] sbox = new byte[256];
        private int i = 0;
        private int j = 0;

        public readonly byte[] Key;


        public RC4U(byte[] key)
        {
            Key = key;

            int length = key.Length;

            for (int i = 0; i < 256; i++)
            {
                sbox[i] = (byte)i;
            }

            int k = 0;

            for (int i = 0; i < 256; i++)
            {
                k = (k + sbox[i] + key[i % length]) % 256;
                Swap<byte>(ref sbox[i], ref sbox[k]);
            }
        }


        public byte[] Process(byte[] value)
        {
            int length = value.Length;
            byte[] tmp = new byte[length];

            for (int n = 0; n < length; n++)
            {
                i = ++i % 256;
                j = (j + sbox[i]) % 256;
                Swap<byte>(ref sbox[i], ref sbox[j]);
                byte rand = sbox[(sbox[i] + sbox[j]) % 256];
                tmp[n] = (byte)(rand ^ value[n]);
            }

            return tmp;
        }


        private void Swap<T>(ref T a, ref T b)
        {
            T c = a;
            a = b;
            b = c;
        }
    }
    public class RC4Encryptor
    {

        private RC4U rc4In;
        private RC4U rc4Out;


        public RC4Encryptor(byte[] key)
        {
            rc4In = new RC4U(key);
            rc4Out = new RC4U(key);
        }


        public byte[] Encrypt(byte[] buffer)
        {
            return rc4Out.Process(buffer);
        }


        public byte[] Decrypt(byte[] buffer)
        {
            return rc4In.Process(buffer);
        }
    }
}
